import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.util.Iterator;
import java.util.ArrayList;


/** Klassendefinition zum Erzeugen einer Zeichenflche fr die Moebel
 * 
 * Gegenber einem einfachen PaintPanel stellt diese Klasse auch noch Methoden
 * fr die Listen von Grafikelementen bereit.
 * Es wird davon ausgegangen, dass die Listen Objekte vom Typ FarbigesShape enthalten.
 * 
 * @author claus albowski
 * @version august 06
 */

class Zeichenflaeche
extends JPanel 
{
    private Image leinwandImage;
    private Graphics2D graphic;
    private ArrayList<FarbigesShape> grafikElemente;
    
    // Konstruktor
    public Zeichenflaeche(int breite, int hoehe)
    {
        grafikElemente = new ArrayList<FarbigesShape>();
        setSize(breite, hoehe);
    }
    
    /**
     * setzt die Liste der elemente neu.
     */
    public void setList(ArrayList<FarbigesShape> liste){
        grafikElemente=liste;
    }
    
    /**
     * spezielle paint - Methode fr die Kchenmbel
     */
    public void paint(Graphics g) 
    {
        graphic=(Graphics2D)g;
        graphic.setColor(Color.white);
        graphic.fillRect(0, 0, getSize().width, getSize().height);
        for (Iterator it=grafikElemente.iterator();it.hasNext();){
            FarbigesShape aktuell= (FarbigesShape) it.next();
            graphic.setColor(aktuell.getColor());
            if (aktuell.getVoll())
            graphic.fill(aktuell.getShape());
            else graphic.draw(aktuell.getShape());
        }
    }   
}